require 'csv'
require_relative 'record'

class DnsZoneParser

  attr_accessor :file_contents
  attr_accessor :records

  def initialize(filename)

    raise StandardError, "\n\nUsage: dns_zone_parser <FILENAME>\n\n" if filename.nil?

    @file_contents = File.open(filename).readlines
    @records = []

  end

  def write_csv_file

    parse_zone_file

    CSV.open("parsed_dns_zone.csv", "w") do |csv|
      @records.each do |record|

        # Build array from Record object instance variables
        record_array = []
        record_array << record.record_type
        record_array << record.class_type
        record_array << record.domain
        record_array << record.ip_address
        record_array << record.time_out

        csv << record_array

      end
    end

    puts "Congratulations! Your zone file was parsed to a CSV file named: 'parsed_dns_zone.csv'."

  end

  def parse

    # Parse zone file into sections delimited by class types
    parse_zone_file

    # Return the array of Record objects
    @records

  end

private

  def parse_zone_file

    @file_contents.each_with_index do |line, index|

      # Each record in the zone file contains the following pattern: "\tIN\t"
      if line.include? ("\tIN\t")

        # Parse each record from the file and save it into a Record object
        record = extract_record(line)

        # Save each Record object into an array of Record objects
        @records << record

      end

    end

  end

  def extract_record(record)

    # Create an Array object from the tab-delimited string
      array_record = record.split(/\t/)
      record = Record.new(array_record)
  end

end
